/*********************************************************************
 *      compiler.h - some defines for dsp registers
 *      Copyright (C) 2000 Rui Sousa 
 ********************************************************************* 
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version. 
 * 
 *     This program is distributed in the hope that it will be useful, 
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of 
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *     GNU General Public License for more details. 
 * 
 *     You should have received a copy of the GNU General Public 
 *     License along with this program; if not, write to the Free 
 *     Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, 
 *     USA. 
 ********************************************************************* 
*/

#ifndef _COMPILER_H
#define COMPILER_H

#define DSP_CODE_SIZE 1024

int dsp_code[DSP_CODE_SIZE];

int ip;

/* nicer names */

#define MAC_S(z, w, x, y) OP(0, (z), (w), (x), (y))
#define MAC_1S(z, w, x, y) OP(1, (z), (w), (x), (y))
#define MAC_W(z, w, x, y) OP(2, (z), (w), (x), (y))
#define MAC_1W(z, w, x, y) OP(3, (z), (w), (x), (y))

#define MACINT_S(z, w, x, y) OP(4, (z), (w), (x), (y))
#define MACINT_W(z, w, x, y) OP(5, (z), (w), (x), (y))

#define ACC3(z, w, x, y) OP(6, (z), (w), (x), (y))
#define MACMV(z, w, x, y) OP(7, (z), (w), (x), (y))
#define ANDXOR(z, w, x, y) OP(8, (z), (w), (x), (y))
#define TSTNEG(z, w, x, y) OP(9, (z), (w), (x), (y))
#define LIMIT(z, w, x, y) OP(10, (z), (w), (x), (y))
#define LIMIT_1(z, w, x, y) OP(11, (z), (w), (x), (y))
#define LOG(z, w, x, y) OP(12, (z), (w), (x), (y))
#define EXP(z, w, x, y) OP(13, (z), (w), (x), (y))
#define INTERP(z, w, x, y) OP(14, (z), (w), (x), (y))
#define SKIP(z, w, x, y) OP(15, (z), (w), (x), (y))


#define AND(z, x , y)	ANDXOR((z), (x), (y), C_0)
#define XOR(z, x, y)	ANDXOR((z), 0x050, (x), (y))
#define NEG(z, x)	ANDXOR((z), (x), 0x050, 0x050)
//#define NAND(z, x, y)	ANDXOR((z),

#define SPDIF_L IN_L(1)
#define SPDIF_R IN_R(1)

#define REAR_L OUT_L(4)
#define REAR_R OUT_R(4)

/* constants */

#define C_0     0x040
#define C_1     0x041
#define C_2     0x042
#define C_3     0x043
#define C_4     0x044
#define C_8	0x045
#define C_16    0x046
#define C_32	0x047
#define C_256	0x048

/* accumulator */

#define ACCUM    0x056

#endif
